<?php
/*****************************************************************************/
/* Search.php                                                                */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$searchphpver = 'YaBB SE 1.5.1';

function plushSearch1()
{
	global $yytitle, $txt, $censored, $curposlinks, $mbname, $imagesdir, $settings, $scripturl, $color, $db_prefix, $modSettings, $advanced;
	$yytitle = $txt[183];
	template_header();
	//LoadCensorList();
	$searchpageurl = ($curposlinks ? "<a href=\"$scripturl?action=search\" class=\"nav\">$txt[182]</a>" : $txt[182]);

	# Build the link tree
	$displayLinkTree = ($modSettings['enableInlineLinks'] ? "<font size=\"1\" class=\"nav\"><b><a href=\"$scripturl\" class=\"nav\">$mbname</a> </b>&nbsp;|&nbsp; " : "<font size=\"2\" class=\"nav\"><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<b><a href=\"$scripturl\" class=\"nav\">$mbname</a></b><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<b>$searchpageurl</b></font>" : "<img src=\"$imagesdir/tline.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<b>$searchpageurl</b></font>");

	$simpleSearch = ($modSettings['simpleSearch'] == '1' && $advanced != '1');

	echo '
		<script language="JavaScript1.2" type="text/javascript">
		<!-- Begin
			function changeBox(cbox)
			{
				box = eval(cbox);
				box.checked = !box.checked;
			}
		//  End -->
		</script>
		<script language="JavaScript" type="text/javascript">
		<!--
			function checkAll()
			{
				for (var i = 0; i < document.searchform.elements.length; i++) {
					if (document.searchform.elements[i].name != "subfield" && document.searchform.elements[i].name != "msgfield") {
						document.searchform.elements[i].checked = true;
					}
				}
			}
			function uncheckAll()
			{
				for (var i = 0; i < document.searchform.elements.length; i++) {
					if (document.searchform.elements[i].name != "subfield" && document.searchform.elements[i].name != "msgfield") {
						document.searchform.elements[i].checked = false;
					}
				}
			}
		//-->
		</script>
		<form action="' . $scripturl . '?action=search2" method="post" name="searchform" id="searchform">
		<table width="80%" border="0" cellspacing="0" cellpadding="3" align="center">
			<tr>
				<td>' . $displayLinkTree . '</td>
			</tr>
		</table>

		<table width="80%" border="0" cellspacing="1" cellpadding="4" align="center" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '">' . $txt[183] . '</font></td>
			</tr><tr>
				<td bgcolor="' . $color['windowbg'] . '" class="windowbg">
					<font size="2">
						<b>' . $txt[582] . ':</b><br />
						<input type="text" name="search" size="40" />&nbsp;';
	if ($simpleSearch)
	{
		echo '
						<input type="submit" name="submit" value="' . $txt[182] . '" /><br />
						<a href="' . $scripturl . '?action=search;advanced=1">' . $txt['yse298'] . '</a>
						<input type="hidden" name="advanced" value="0" />
					</font>
				</td>
			</tr>
		</table>
		</form>';
	}
	else
	{
		echo '
						<input type="hidden" name="advanced" value="1" />
						<select name="searchtype">
							<option value="allwords" selected="selected">' . $txt[343] . '</option>
							<option value="anywords">' . $txt[344] . '</option>
							<option value="asphrase">' . $txt[345] . '</option>
						</select><br />
						<b>' . $txt[583] . ':</b><br />
						<input type="text" name="userspec" size="40" />&nbsp;
						<select name="userkind">
							<option value="any">' . $txt[577] . '</option>
							<option value="starter">' . $txt[186] . '</option>
							<option value="poster">' . $txt[187] . '</option>
							<option value="noguests" selected="selected">' . $txt[346] . '</option>
							<option value="onlyguests">' . $txt[572] . '</option>
						</select>
					</font><br />
					<font size="2"><b>' . $txt[189] . ':</b></font><br /><br />
					<table width="80%" border="0" cellpadding="1" cellspacing="0">';

		$request = mysql_query("SELECT b.ID_BOARD, b.name FROM {$db_prefix}boards AS b, {$db_prefix}categories AS c WHERE (b.ID_CAT=c.ID_CAT && (FIND_IN_SET('$settings[7]',c.memberGroups) != 0 || '$settings[7]'='Administrator' || '$settings[7]'='Global Moderator' || c.memberGroups=''));") or database_error(__FILE__, __LINE__);
		$counter = 1;
		while ($row = mysql_fetch_row($request))
		{
			if (($counter % 2))
				echo '<tr>';
			echo '<td width="50%"><font size="2"><input type="checkbox" name="brd' . $row[0] . '" value="1" checked="checked" /><span id="spanbrd' . $row[0] . '" style="cursor:hand;" onclick="changeBox(\'document.searchform.brd' . $row[0] . '\')">' . $row[1] . '</span></font></td>';
			if (!($counter % 2))
				echo '</tr>';
			$counter++;
		}
		if (!($counter % 2))
			echo '<td>&nbsp;</td></tr>';

		echo '
					</table><br />
					<input type="checkbox" name="all" value="" checked="checked" onclick="if (this.checked) checkAll(); else uncheckAll();" /><font size="2"><i>' . $txt[737] . '</i></font>
					<br /><br /><font size="2"><b>' . $txt[573] . ':</b></font><br />
					<table border="0" cellpadding="2" cellspacing="0">
						<tr>
							<td><font size="2"><input type="checkbox" name="subfield" value="on" checked="checked" /><span id="spansubfield" style="cursor:hand;" onclick="changeBox(\'document.searchform.subfield\')">' . $txt[70] . '</span></font></td>
							<td><font size="2"><input type="checkbox" name="msgfield" value="on" checked="checked" /><span id="spanmsgfield" style="cursor:hand;" onclick="changeBox(\'document.searchform.msgfield\')">' . $txt[72] . '</span></font></td>
						</tr>
					</table>
					<br />
					<table border="0" cellpadding="2" cellspacing="0">
						<tr>
							<td>
								<font size="2"><b>' . $txt[575] . ' ' . $txt[574] . ':</b><br />
								<input type="text" name="minripe" value="0" size="3" maxlength="5" /> ' . $txt[578] . ' +
								<input type="text" name="minage" value="0" size="5" maxlength="5" /> ' . $txt[579] . '.</font>
							</td>
							<td>
								<font size="2"><b>' . $txt[576] . ' ' . $txt[574] . ':</b><br />
								<input type="text" name="maxripe" value="0" size="3" maxlength="5" /> ' . $txt[578] . ' +
								<input type="text" name="maxage" value="60" size="5" maxlength="5" /> ' . $txt[579] . '.</font>
							</td>
						</tr>
					</table>
					<br />
					<table border="0" cellpadding="2" cellspacing="0" align="left">
						<tr>
							<td valign="bottom">
								<font size="2"><b>' . $txt[191] . '</b><br /></font>
								<input type="text" size="5" name="numberreturned" maxlength="5" value="50" />
							</td>
						</tr><tr>
							<td valign="bottom">
								<input type="hidden" name="action" value="dosearch" />
								<input type="submit" name="submit" value="' . $txt[182] . '" />
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		</form>';
	}
	footer();
	obExit();
}

function plushSearch2()
{
	global $minripe, $minage, $maxripe, $maxage, $numberreturned, $userkind, $userspec, $searchtype, $search;
	global $subfield, $msgfield, $timeoffset, $settings, $yytitle, $txt, $maxmessagedisplay, $enable_notification;
	global $menusep, $scripturl, $cgi, $img, $color, $db_prefix, $imagesdir, $HTTP_POST_VARS, $advanced, $sc;

	$display = $numberreturned;

	if ($advanced == '0')
	{
		// Set the default options for simple search
		$minripe = $minage = $maxripe = 0;
		$maxage = 5 * 365; // 5 years
		$display = 300; // maximum number of topics to show
		$searchtype = 'allwords'; // 'allwords'/'anywords'/'asphrase'
		$subfield = 'on'; // search in subject
		$msgfield = 'on'; //search in message
	}

	// get the age of the latest post
	$request = mysql_query("SELECT posterTime FROM {$db_prefix}messages ORDER BY ID_MSG DESC LIMIT 1;") or database_error(__FILE__, __LINE__);
	list ($latestAge) = mysql_fetch_row($request);
	if (!is_numeric($minripe) || !is_numeric($minage) || !is_numeric($maxripe) || !is_numeric($maxage) || !is_numeric($display))
		fatal_error($txt[337]);

	if ($userkind == 'starter')
		$userkind = 1;
	else if ($userkind == 'poster')
		$userkind = 2;
	else if ($userkind == 'noguests')
		$userkind = 3;
	else if ($userkind == 'onlyguests')
		$userkind = 4;
	else
	{
		$userkind = 0;
		$userspec = '';
	}

	$userspec = trim($userspec);
	$userspec = preg_replace("/[^0-9A-Za-z#%+,-\.@^_]/", "", $userspec);

	if ($searchtype == 'anywords' )
		$searchtype = 2;
	else if ($searchtype == 'asphrase' )
		$searchtype = 3;
	else
		$searchtype = 1;

	$searchsubject = ($subfield == 'on');
	$searchmessage = ($msgfield == 'on');

	if (get_magic_quotes_gpc() == 0)
		$search = addslashes($search);
	$search = trim($search);
	$find = array("&", "\"", "<", ">", "\t", "|");
	$replace = array("&amp;", "&quot;", "&lt;", "&gt;", "&nbsp;&nbsp;&nbsp;", "&#124;");
	$search = str_replace($find, $replace, $search);

	$searcharray = array($search);
	if ($searchtype != 3)
	{
		$searcharray = array();
		foreach (explode(' ', $search) as $s)
			if (trim($s) != '')
				$searcharray[]=trim($s);
	}

	// Read the boards that have been selected
	$boards = array();
	foreach ($HTTP_POST_VARS as $postName => $postValue)
		if (substr($postName, 0, 3) == "brd" && is_numeric(substr($postName, 3)))
			$boards[] = substr($postName, 3);

	if (count($boards) == 0 || $advanced == '0')
		$boardsWhere = '1';
	else
		$boardsWhere = 'b.ID_BOARD IN (' . implode(',', $boards) . ')';

	// Find all the boards that are checked by the user AND the user is allowed to see
	$request = mysql_query("
		SELECT b.ID_BOARD
		FROM {$db_prefix}boards AS b, {$db_prefix}categories AS c
		WHERE $boardsWhere
			AND c.ID_CAT=b.ID_CAT
			AND (FIND_IN_SET('$settings[7]',c.memberGroups) != 0 || '$settings[7]'='Administrator' || '$settings[7]'='Global Moderator' || c.memberGroups='')") or database_error(__FILE__, __LINE__);

	if (mysql_num_rows($request) == '0')
		fatal_error('no valid boards selected');

	$boards = array();
	while ($row = mysql_fetch_array($request))
		$boards[] = $row['ID_BOARD'];

	$boardsWhere = 't.ID_BOARD IN (' . implode(',', $boards) . ') &&';

	$mintime = $latestAge - (($minage * 86400)+($minripe * 3600));
	$maxtime = $latestAge - (($maxage * 86400)+($maxripe * 3600));

	$yytitle = $txt[166];
	template_header();

	$results = array();
	foreach ($searcharray as $query)
	{
		$where = '';
		$query = strtolower($query);
		if ($userkind == 1 && $userspec == '')
			$where = "($boardsWhere m.ID_MSG=t.ID_FIRST_MSG && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else if ($userkind == 1 && $userspec != '')
			$where = "($boardsWhere m.ID_MSG=t.ID_FIRST_MSG && m.posterName='$userspec' && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else if ($userkind == 2 && $userspec == '')
			$where = "($boardsWhere m.ID_TOPIC=t.ID_TOPIC && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else if ($userkind == 2 && $userspec != '')
			$where = "($boardsWhere m.ID_TOPIC=t.ID_TOPIC && m.posterName='$userspec' && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else if ($userkind == 3 && $userspec == '')
			$where = "($boardsWhere m.ID_TOPIC=t.ID_TOPIC && m.ID_MEMBER != -1 && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else if ($userkind == 3 && $userspec != '')
			$where = "($boardsWhere m.ID_TOPIC=t.ID_TOPIC && m.ID_MEMBER != -1 && m.posterName='$userspec' && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else if ($userkind == 4 && $userspec == '')
			$where = "($boardsWhere m.ID_TOPIC=t.ID_TOPIC && m.ID_MEMBER=-1 && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else if ($userkind == 4 && $userspec != '')
			$where = "($boardsWhere m.ID_TOPIC=t.ID_TOPIC && m.ID_MEMBER=-1 && m.posterName='$userspec' && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";
		else
			$where = "($boardsWhere m.ID_TOPIC=t.ID_TOPIC && (INSTR(LOWER(m.subject),'$query') || INSTR(LOWER(m.body),'$query')) && m.posterTime <= $mintime && m.posterTime > $maxtime)";

		$request = mysql_query("SELECT m.ID_MSG FROM {$db_prefix}topics AS t, {$db_prefix}messages AS m WHERE $where ORDER BY m.posterTime DESC LIMIT $display;") or database_error(__FILE__, __LINE__);

		if (mysql_errno())
			fatal_error($txt['yse230']);

		while ($row = mysql_fetch_row($request))
		{
			if (!isset($results[$row[0]]))
				$results[$row[0]]=1;
			else
				$results[$row[0]]++;
		}
	}
	$display = ($display < sizeof($results))?$display:sizeof($results);

	$count = 0;
	foreach ($results as $msg => $counts)
	{
		if ($searchtype == 1 && $counts < sizeof($searcharray))
			continue;
		if ($count == $display)
			break;
		else
			$count++;
		$request = mysql_query("
			SELECT mes.ID_MEMBER AS starterID, mes.posterName AS starterName, m.subject, m.body, m.posterName, m.posterTime, m.smiliesEnabled, m.ID_MEMBER, t.ID_TOPIC, b.name AS bname, b.ID_BOARD, c.name AS cname, mem.memberName, mem.realName, mem2.memberName AS starterMemberName, mem2.realName AS starterRealName
			FROM {$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}categories AS c, {$db_prefix}boards AS b,{$db_prefix}messages AS mes
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=m.ID_MEMBER)
				LEFT JOIN {$db_prefix}members AS mem2 ON (mem2.ID_MEMBER=mes.ID_MEMBER)
			WHERE m.ID_MSG=$msg
				AND t.ID_TOPIC=m.ID_TOPIC
				AND b.ID_BOARD=t.ID_BOARD
				AND c.ID_CAT=b.ID_CAT
				AND mes.ID_MSG=t.ID_FIRST_MSG
			LIMIT 1;") or database_error(__FILE__, __LINE__);
		$row = mysql_fetch_assoc($request);

		// create the "topic started by" string
		$starterString = "$txt[109] $row[starterName]";
		if ($row['starterID'] != '-1')
		{
			$euser = urlencode($row['starterMemberName']);
			$starterString = "$txt[109] <a href=\"$cgi;action=viewprofile;user=$euser\">$row[starterRealName]</a>";
		}

		// And parse UBBC (Zef)
		$row['body'] = doUBBC($row['body'], $row['smiliesEnabled']);
		CensorTxt($row['body']);
		CensorTxt($row['subject']);

		foreach ($searcharray as $query)
			$row['body'] = preg_replace("/((<[^>]*)|" . str_replace("/", "\\/", quotemeta($query)) . ")/ie", '"\2"=="\1" ? "\1" : "<b>\1</b>"', $row['body']);
		$row['posterTime'] = timeformat($row['posterTime']);

		//Compose message button bar
		$messageButtons = array();
		$messageButtons[] = '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . ';action=post;threadid=' . $row['ID_TOPIC'] . ';title=Post+reply">' . $img['reply_sm'] . '</a>';
		$messageButtons[] = '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . ';action=post;threadid=' . $row['ID_TOPIC'] . ';quote=' . $msg . ';title=Post+reply;sesc=' . $sc . '">' . $img['replyquote'] . '</a>';
		if ($enable_notification)
			$messageButtons[] = "<a href=\"$scripturl?board=$row[ID_BOARD];action=notify;threadid=$row[ID_TOPIC];start=$start\">$img[notify_sm]</a>";


		$euser = urlencode($row['memberName']);
		$namelink = ($row['ID_MEMBER'] != -1 ? "<a href=\"$cgi;action=viewprofile;user=$euser\">$row[realName]</a>" : $row['posterName']);

		echo '
			<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td>
						<table border="0" width="100%" cellpadding="2" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
							<tr>
								<td align="left" bgcolor="' . $color['titlebg'] . '" class="titlebg"><font class="text1" color="' . $color['titletext'] . '" size="2">&nbsp;' . $count . '&nbsp;</font></td>
								<td bgcolor="' . $color['titlebg'] . '" class="titlebg"><font class="text1" color="' . $color['titletext'] . '" size="2"><b>&nbsp;' . $row['cname'] . ' / ' . $row['bname'] . ' / <a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . ';action=display;threadid=' . $row['ID_TOPIC'] . ';start=msg' . $msg . '#msg' . $msg . '"><font class="text1" color="' . $color['titletext'] . '" size="2">' . $row['subject'] . '</font></a></b></font></td>
								<td align="right" bgcolor="' . $color['titlebg'] . '" class="titlebg">&nbsp;<font class="text1" color="' . $color['titletext'] . '" size="2">' . $txt[30] . ': ' . $row['posterTime'] . '&nbsp;</font></td>
							</tr><tr>
								<td colspan="3" bgcolor="' . $color['catbg'] . '" class="catbg"><font class="catbg" size="2">' . $starterString . ', ' . $txt[72] . ' ' . $txt[525] . ' ' . $namelink . '</font></td>
							</tr><tr>
								<td colspan="3" bgcolor="' . $color['windowbg2'] . '" valign="top" class="windowbg2" height="80"><font size="2">' . $row['body'] . '</font></td>
							</tr><tr>
								<td colspan="3" bgcolor="' . $color['catbg'] . '" class="windowbg">
									<font size="2">&nbsp;' . implode($menusep, $messageButtons) . '</font>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table><br />';
	}

	echo $txt[167] . '<hr /><font size="1"><a href="' . $cgi . '">' . $txt[236] . '</a> ' . $txt[237] . '<br /></font>';
	footer();
	obExit();
}

?>