<?php
/*****************************************************************************/
/* Post.php                                                                  */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$postphpver = 'YaBB SE 1.5.2';

function Post ()
{
	global $username, $password, $enable_guestposting, $txt, $img, $title, $start;
	global $board, $quote, $enable_notification, $yytitle, $ubbcjspath, $scripturl;
	global $enable_ubbc, $showyabbcbutt, $realname, $realemail, $imagesdir, $mbname;
	global $cgi, $color, $threadid, $settings, $moderators, $db_prefix, $modSettings;
	global $sourcedir, $linkcalendar, $sc;

	if (isset($linkcalendar))
	{
		include_once "$sourcedir/Calendar.php";
		CalendarValidatePost();
	}

	if ($username == 'Guest' && $enable_guestposting == 0)
		fatal_error($txt[165]);

	if ($board == '' )
		fatal_error($txt[1]);

	$quotemsg = $quote;

	$threadinfo = array('locked' => 0, 'ID_MEMBER_STARTED'=>'-1');
	$mstate = 0;

	if ($threadid != '')
	{
		$request = mysql_query("
			SELECT * FROM {$db_prefix}topics
			WHERE ID_TOPIC=$threadid") or database_error(__FILE__, __LINE__);

		$threadinfo = mysql_fetch_array($request);
		$mstate = $threadinfo['locked'];
	}
	else if ($title != $txt[464])
		fatal_error ($txt[472] . ' Error ' . $title);

	if ($threadinfo['locked'] != 0 && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator' && !in_array($username, $moderators))        // don't allow a post if it's locked
		fatal_error($txt[90]);

	# Determine what category we are in.
	$request = mysql_query("
		SELECT b.ID_BOARD as bid, b.name as bname, c.ID_CAT as cid, c.memberGroups, c.name as cname, b.isAnnouncement
		FROM {$db_prefix}boards as b, {$db_prefix}categories as c
		WHERE (b.ID_BOARD = $board
			AND b.ID_CAT=c.ID_CAT)") or database_error(__FILE__, __LINE__);

	if (mysql_num_rows($request) == 0)
		fatal_error($txt['yse232']);

	$bcinfo = mysql_fetch_array($request);
	$curcat = $bcinfo['cid'];
	$cat = $bcinfo['cname'];
	$currentboard = $bcinfo['bid'];
	$boardname = $bcinfo['bname'];

	if ($bcinfo['isAnnouncement'] && $threadid == '' && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator' && !in_array($username, $moderators))
		fatal_error($txt['announcement1']);

	$memgroups = explode(',', $bcinfo['memberGroups']);
	if (!(in_array($settings[7], $memgroups) || $memgroups[0] == null || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator'))
		fatal_error($txt[1]);

	$notification = (!$enable_notification || $username == 'Guest') ? '' : '
		<tr>
			<td align="right">
				<font size="2"><b>' . $txt[131] . ':</b></font>
			</td>
			<td>
				<font size="2"><input type="checkbox" name="notify" /></font><font size="1"> ' . $txt['yse14'] . '</font>
			</td>
		</tr>';

	$lockthread = (($settings[7] != 'Administrator' && $settings[7] != 'Global Moderator' && !in_array($username, $moderators)) || $threadinfo['locked']) ? '' : '
		<tr>
			<td align="right">
				<font size="2"><b>' . $txt['yse13'] . ':</b></font>
			</td>
			<td>
				<font size="2"><input type="checkbox" name="lock" /></font><font size="1"> ' . $txt['yse15'] . '</font>
			</td>
		</tr>';

	$lockWarning = (!$threadinfo['locked']) ? '' : '
		<tr>
			<td>&nbsp;</td>
			<td align="left">
				<font size="2">' . $txt['yse287'] . '</font>
			</td>
		</tr>';


	if ($title == $txt[464])
		$title=$txt[33];
	else if ($title == $txt[116])
		$title=$txt[25];

	$title = str_replace("\\","",$title);
	$yytitle = $title;
	template_header();

	$name_field = ($realname == '' ? '
		<tr>
			<td align="right">
				<font size="2"><b>' . $txt[68] . ':</b></font>
			</td>
			<td>
				<font size="2"><input type="text" name="name" size="25" /></font>
			</td>
		</tr>' : '');

	$email_field = ($realemail == '' ? '
		<tr>
			<td align="right">
				<font size="2"><b>' . $txt[69] . ':</b></font>
			</td>
			<td>
				<font size="2"><input type="text" name="email" size="25" /></font>
			</td>
		</tr>' : '');

	$msubject = $mname = $memail = $mdate = $musername = $micon = $mip = $mmessage = $mns = $mid = '';
	$form_message = '';
	$form_subject = '';
	if ($threadid != '' && $quotemsg != '')
	{
		checkSession('get');

		$request = mysql_query("
			SELECT m.subject, m.posterName, m.posterEmail, m.posterTime, m.icon, m.posterIP, m.body, m.smiliesEnabled, m.ID_MEMBER
			FROM {$db_prefix}messages as m, {$db_prefix}topics as t, {$db_prefix}boards as b, {$db_prefix}categories as c
			WHERE (m.ID_MSG = $quotemsg
				AND m.ID_TOPIC = t.ID_TOPIC
				AND t.ID_BOARD = b.ID_BOARD
				AND b.ID_CAT = c.ID_CAT
				AND (FIND_IN_SET('$settings[7]', c.memberGroups) != 0 || c.memberGroups = '' || '$settings[7]' LIKE 'Administrator' || '$settings[7]' LIKE 'Global Moderator')
				)") or database_error(__FILE__, __LINE__);

		list($msubject, $mname, $memail, $mdate, $micon, $mip, $mmessage, $mns, $mi) = mysql_fetch_row($request);

		if ($mi != '-1')
		{
			$request = mysql_query("
				SELECT realName
				FROM {$db_prefix}members
				WHERE ID_MEMBER='$mi'
				LIMIT 1") or database_error(__FILE__, __LINE__);

			if (mysql_num_rows($request) != 0)
				list($mname) = mysql_fetch_row($request);
		}

		$form_message = un_html_entities(preg_replace("|<br( /)?[>]|","\n",$mmessage));
		CensorTxt($form_message);
		if ($modSettings['removeNestedQuotes'] == '1')
		{
			$form_message = preg_replace("-\n*\[quote([^\\]]*)\]((.|\n)*?)\[/quote\]([\n]*)-", '', $form_message);
			$form_message = preg_replace("/\n*\[\/quote\]\n*/", '', $form_message);
		}
		$form_message = '[quote author=' . $mname . ' link=board=' . $currentboard . ';threadid=' . $threadid . ';start=' . $start . '#msg' . $quotemsg . ' date=' . $mdate . ']' . "\n" . htmlspecialchars($form_message, ENT_QUOTES) . "\n" . '[/quote]';
		$form_subject = $msubject;
		CensorTxt($form_subject);

		if (!stristr(substr($msubject, 0, 3), 're:'))
			$form_subject = 'Re:' . $form_subject;
	}
	else if ($threadid != '' && $quotemsg == '')
	{
		$request = mysql_query("SELECT subject, posterName, posterEmail, posterTime, icon, posterIP, body, smiliesEnabled, ID_MEMBER
		FROM {$db_prefix}messages
		WHERE ID_TOPIC=$threadid
		ORDER BY ID_MSG
		LIMIT 1") or database_error(__FILE__, __LINE__);

		list($msubject, $mname, $memail, $mdate, $micon, $mip, $mmessage, $mns, $mi) = mysql_fetch_row($request);

		$form_subject = $msubject;
		CensorTxt($form_subject);
		if (!stristr(substr($msubject, 0, 3),'re:'))
			$form_subject = 'Re:' . $form_subject;
	}

	if (!$form_subject)
		$sub = '<i>' . $txt[33] . '</i>';
	else
		$sub = $form_subject;

	# Build the link tree
	$displayLinkTree = $modSettings['enableInlineLinks'] ? '<font size="1" class="nav"><b><a href="' . $scripturl . '" class="nav">' . $mbname . '</a> </b>&nbsp;|&nbsp;<b> ' : '<font size="2" class="nav"><b><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;<a href="' . $scripturl . '" class="nav">' . $mbname . '</a><br />';
	$displayLinkTree .= $modSettings['enableInlineLinks'] ? '<a href="' . $scripturl . '#' . $curcat . '" class="nav">' . $cat . '</a> </b>&nbsp;|&nbsp;<b> ' : '<img src="' . $imagesdir . '/tline.gif" border="0" alt="" /><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;<a href="' . $scripturl . '#' . $curcat . '" class="nav">' . $cat . '</a><br />';
	$displayLinkTree .= $modSettings['enableInlineLinks'] ? '<a href="' . $cgi . '" class="nav">' . $boardname . '</a> </b>&nbsp;|&nbsp;<b> ' : '<img src="' . $imagesdir . '/tline2.gif" border="0" alt="" /><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;<a href="' . $cgi . '" class="nav">' . $boardname . '</a><br />';
	$displayLinkTree .= $modSettings['enableInlineLinks'] ? $title . ' ( ' . $sub . ' )</b></font>' : '<img src="' . $imagesdir . '/tline3.gif" border="0" alt="" /><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;' . $title . ' ( ' . $sub . ' )</b></font>';

	echo '
		<script language="JavaScript1.2" src="' . $ubbcjspath . '" type="text/javascript"></script>
		<script language="JavaScript1.2" type="text/javascript">
		<!--
		function showimage()
		{
			document.images.icons.src="' . $imagesdir . '/" + document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value + ".gif";
		}
		function updateFields()
		{
			if (document.layers || document.all || document.getElementById)
			{
				pForm = document.postmodify;
				pForm.attachmentp.value = pForm.attachment.value;
			}
		}
		//-->
		</script>

		<form action="' . $cgi . ';action=post2" method="post" name="postmodify" onsubmit="if (document.postmodify.subject.value == \'\' || document.postmodify.message.value == \'\') { alert(\'' . $txt['jsvalidate1'] . '\'); return false; } else { submitonce(this); }" enctype="multipart/form-data">
			<table  width="75%" align="center" cellpadding="0" cellspacing="0">
				<tr>
					<td valign="bottom" colspan="2">
						' . $displayLinkTree . '
					</td>
				</tr>
			</table>

			<table border="0"  width="75%" align="center" cellspacing="1" cellpadding="3" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
						<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $yytitle . '</b></font>
					</td>
				</tr>
				<tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
					<input type="hidden" name="threadid" value="' . $threadid . '" />
					<table border="0" cellpadding="3" width="100%">
							' . $lockWarning . '
							' . $name_field . '
							' . $email_field . '
							<tr>
								<td align="right">
									<font size="2"><b>' . $txt[70] . ':</b></font>
								</td>
							<td>
								<font size="2"><input type="text" name="subject" value="' . addcslashes($form_subject, '"') . '" size="40" maxlength="80" /></font>
							</td>
							</tr>
							<tr>
								<td align="right">
									<font size="2"><b>' . $txt[71] . ':</b></font>
								</td>
								<td>
									<select name="icon" onchange="showimage()">
										<option value="xx">' . $txt[281] . '</option>
										<option value="thumbup">' . $txt[282] . '</option>
										<option value="thumbdown">' . $txt[283] . '</option>
										<option value="exclamation">' . $txt[284] . '</option>
										<option value="question">' . $txt[285] . '</option>
										<option value="lamp">' . $txt[286] . '</option>
										<option value="smiley">' . $txt[287] . '</option>
										<option value="angry">' . $txt[288] . '</option>
										<option value="cheesy">' . $txt[289] . '</option>
										<option value="grin">' . $txt[293] . '</option>
										<option value="sad">' . $txt[291] . '</option>
										<option value="wink">' . $txt[292] . '</option>
									</select>
									<img src="' . $imagesdir . '/xx.gif" name="icons" border="0" hspace="15" alt="" />
								</td>
							</tr>';

	printPostBox($form_message);

	$attachmentFields = '';
	if ($modSettings['attachmentEnable'] == 1)
		$attachmentFields = '
							<tr>
								<td align="right" valign="top">
									<font size="2"><b>' . $txt['yse119'] . ':</b></font><br /><br />
								</td>
								<td>
									<input type="file" size="48" name="attachment" onchange="updateFields();" /><br />
									<font size="1">' . $txt['yse120'] . ': ' . $modSettings['attachmentExtensions'] . '<br />
									' . $txt['yse121'] . ': ' . $modSettings['attachmentSizeLimit'] . ' KB</font>
									<input type="hidden" name="attachmentp" value="" /><br /><br />
								</td>
							</tr>';

	if ($username == 'Guest' && $modSettings['attachmentEnableGuest'] == 0)
		$attachmentFields = '';

	// Administrator & Global Moderator can't upload attachments when description was changed
	if ($modSettings['attachmentMemberGroups'] != '')
		if (!(in_array($settings[7], explode(',', trim($modSettings['attachmentMemberGroups']))) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator'))
			$attachmentFields = '';

	if (isset($linkcalendar))
		CalendarAddHidden();

	echo '
							' . $lockthread . '
							' . $notification . '
							<tr>
								<td align="right">
									<font size="2"><b>' . $txt[276] . ':</b></font><br /><br />
								</td>
								<td>
									<input type="checkbox" name="ns" value="NS" /><font size="1"> ' . $txt[277] . '</font><br /><br />
								</td>
							</tr>
							' . $attachmentFields . '
							<tr>
								<td align="center" colspan="2">
									<font size="1" class="text1" color="#000000"><font style="font-weight:normal" size="1">' . $txt['yse16'] . '</font></font><br />
									<input type="hidden" name="waction" value="post" />
									<input type="submit" name="post" value="' . $txt[105] . '" onclick="WhichClicked' . "('post')" . ';" accesskey="s" />
									<input type="submit" name="preview" value="' . $txt[507] . '" onclick="WhichClicked' . "('preview')" . ';" accesskey="p" />
									<input type="reset" value="' . $txt[278] . '" accesskey="r" />
								</td>
							</tr>
							<tr>
								<td colspan="2"></td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			<input type="hidden" name="sc" value="' . $sc . '" />
		</form>';

	if ($threadid > 0)
		doshowthread();

	footer();
	obExit();
}

function Preview ()
{
	global $name, $email, $subject, $message, $icon, $ns, $threadid, $notify, $enable_ubbc, $txt, $waction, $db_prefix;
	global $censored, $yytitle, $imagesdir, $cgi, $to, $from, $board, $username, $ubbcjspath, $postid, $color, $modSettings;
	global $sourcedir, $realname, $lock, $enable_notification, $settings, $realemail, $moderators, $start, $postid;
	global $attachmentp, $sc, $linkcalendar;

	if (isset($linkcalendar))
	{
		include_once "$sourcedir/Calendar.php";
		CalendarValidatePost();
	}

	if (strlen($subject) > 80)
		$subject = substr($subject,0,80);
	
	if (get_magic_quotes_gpc())
	{
		$subject = stripcslashes($subject);
		$message = stripcslashes($message);
	}
	$subject = htmlspecialchars($subject);
	$message2 = $message;
	$message2 = htmlspecialchars($message2, ENT_QUOTES);
	$message2 = str_replace("\t","&nbsp;&nbsp;&nbsp;",$message2);
	$message2 = str_replace("\r","",$message2);
	$message2 = str_replace("\n","<br />",$message2);
	if ($enable_ubbc)
	{
		$message2 = preparsecode($message2, $realname, $username);
		$es = ($ns == ' checked') ? 0 : 1;
		$message2 = DoUBBC($message2, $es);
	}

	// create the options at the bottom
	$notify = ($notify != '') ? ' checked' : '';
	$ns = isset($ns) ? ' checked' : '';
	$lock = ($lock != '') ? ' checked' : '';

	$name_field = ($realname == '' ? '
		<tr>
			<td align="right">
				<font size="2"><b>' . $txt[68] . ':</b></font>
			</td>
			<td>
				<font size="2"><input type="text" name="name" size="25" value="' . $name . '" /></font>
			</td>
		</tr>' : '');

	$email_field = ($realemail == '' ? '
		<tr>
			<td align="right">
				<font size="2"><b>' . $txt[69] . ':</b></font>
			</td>
			<td>
				<font size="2"><input type="text" name="email" size="25" value="' . $email . '" />
			</td>
		</tr>' : '');

	if ($username == 'Guest')
	{
		// we are doing a check to make sure the person posting, isn't using a name
		// that a member has already taken.
		$request = mysql_query("
			SELECT ID_MEMBER
			FROM {$db_prefix}members
			WHERE (memberName='$name' OR realName='$name')
			LIMIT 1") or database_error(__FILE__, __LINE__);

		if (mysql_num_rows($request) > 0)
			fatal_error($txt[100]);

		// now make sure they aren't trying to use a reserved name
		$request = mysql_query("
			SELECT *
			FROM {$db_prefix}reserved_names
			ORDER BY setting") or database_error(__FILE__, __LINE__);

		$matchword = $matchcase = $matchuser = $matchname = '';
		for ($i = 0; $i < 4; $i++)
		{
			$tmp = mysql_fetch_row($request);
			${$tmp[0]}=$tmp[1];
		}
		$namecheck = $matchcase ? $name : strtolower($name);

		while ($tmp = mysql_fetch_row($request))
		{
			if ($tmp[0] == 'word')
			{
				$reserved = $tmp[1];
				$reservecheck = $matchcase ? $reserved : strtolower($reserved);

				if ($matchname)
					if ($matchword)
					{
						if ($namecheck == $reservecheck)
							fatal_error("$txt[244] $reserved");
					}
					else
					{
						if (strstr($namecheck, $reservecheck))
							fatal_error("$txt[244] $reserved");
					}
			}
		}
	}


	$destination = $submittxt = '';
	if ($waction == 'previewmodify')
	{
		$destination = 'modify2;start=' . $start . ';postid=' . $postid;
		$submittxt = $txt[10];
	}
	else if ($waction == 'previewim')
	{
		$destination = 'imsend2';
		$submittxt = $txt[148];
	}
	else
	{
		$destination = 'post2';
		$submittxt = $txt[105];
	}

	$csubject = $subject;

	CensorTxt($csubject);
	CensorTxt($message2);

	$yytitle = "$txt[507] - $csubject";

	template_header();

	echo '
	<script language="JavaScript1.2" src="' . $ubbcjspath . '" type="text/javascript"></script>

	<table border="0" width="75%" cellspacing="1" cellpadding="3" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
		<tr>
			<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
				<font size="2" class="text1" color="' . $color['titletext'] . '">' . $csubject . '</font>
			</td>
		</tr>
		<tr>
			<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
				<font size="2">' . $message2 . '</font>
			</td>
		</tr>
	</table><br />';

	if ($waction != 'previewim')
	{
		echo '
			<script language="JavaScript1.2" type="text/javascript">
			<!--
				function showimage()
				{
					document.images.icons.src="' . $imagesdir . '/" + document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value + ".gif";
				}
			//-->
			</script>

			<table border="0"  width="75%" align="center" cellspacing="1" cellpadding="3" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
						<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $yytitle . '</b></font>
					</td>
				</tr>
				<tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
						<form action="' . $cgi . ';action=' . $destination . '" method="post" name="postmodify" onsubmit="if (document.postmodify.subject.value == \'\' || document.postmodify.message.value == \'\') { alert(\'' . $txt['jsvalidate1'] . '\'); return false; } else { submitonce(this); }" enctype="multipart/form-data">
							<input type="hidden" name="threadid" value="' . $threadid . '" />
							<table border="0" cellpadding="3">
								' . $name_field . '
								' . $email_field . '
								<tr>
									<td align="right">
										<font size="2"><b>' . $txt[70] . ':</b></font>
									</td>
									<td>
										<font size="2"><input type="text" name="subject" value="' . $subject . '" size="40" maxlength="80" /></font>
									</td>
								</tr><tr>
									<td align="right">
										<font size="2"><b>' . $txt[71] . ':</b></font>
									</td>
									<td>
										<select name="icon" onchange="showimage()">
											<option value="xx" ' . ($icon == 'xx' ? 'selected' : '') .  '>' . $txt[281] . '</option>
											<option value="thumbup" ' . ($icon == 'thumbup' ? 'selected' : '') . '>' . $txt[282] . '</option>
											<option value="thumbdown"' . ($icon == 'thumbdown' ? 'selected' : '') . '>' . $txt[283] . '</option>
											<option value="exclamation"' . ($icon == 'exclamation' ? 'selected' : '') . '>' . $txt[284] . '</option>
											<option value="question"' . ($icon == 'question' ? 'selected' : '') . '>' . $txt[285] . '</option>
											<option value="lamp"' . ($icon == 'lamp' ? 'selected' : '') . '>' . $txt[286] . '</option>
											<option value="smiley"' . ($icon == 'smiley' ? 'selected' : '') . '>' . $txt[287] . '</option>
											<option value="angry"' . ($icon == 'angry' ? 'selected' : '') . '>' . $txt[288] . '</option>
											<option value="cheesy"' . ($icon == 'cheesy' ? 'selected' : '') . '>' . $txt[289] . '</option>
											<option value="grin"' . ($icon == 'grin' ? 'selected' : '') . '>' . $txt[293] . '</option>
											<option value="sad"' . ($icon == 'sad' ? 'selected' : '') . '>' . $txt[291] . '</option>
											<option value="wink"' . ($icon == 'wink' ? 'selected' : '') . '>' . $txt[292] . '</option>
										</select>
										<img src="' . $imagesdir . '/' . $icon . '.gif" name="icons" border="0" hspace="15" alt="" />
									</td>
								</tr>';
	}
	else
	{
		echo '
			<table border="0" width="75%" align="center" cellpadding="3" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor"><tr><td class="windowbg" bgcolor="' . $color['windowbg'] . '">
				<form action="' . $scripturl . '?action=imsend2" method="post" name="postmodify" onsubmit="if (document.postmodify.subject.value == \'\' || document.postmodify.message.value == \'\') { alert(\'' . $txt['jsvalidate1'] . '\'); return false; } else { submitonce(this); }" enctype="multipart/form-data">
					<table border="0" cellpadding="3">
						<tr>
							<td align="right">
								<font size="2"><b>' . $txt[150] . ':</b></font>
							</td>
							<td>
								<font size="2"><input type="text" name="to" value="' . $to . '" size="20" maxlength="80" /><font size="1">' . $txt[748] . '</font></font>
							</td>
						</tr>
						<tr>
							<td align="right">
								<font size="2"><b>' . $txt[70] . ':</b></font>
							</td>
							<td>
								<font size="2"><input type="text" name="subject" value="' . $subject . '" size="40" maxlength="80" /></font>
							</td>
						</tr>';
	}

	printPostBox(htmlspecialchars($message));

	if ($waction != 'previewim')
	{
		# Attachment field added by Meriadoc
		$attachmentFields = "";
		if ($modSettings['attachmentEnable'] == 1)
		{
			if (get_magic_quotes_gpc())
			{
				$attachmentp = stripslashes($attachmentp);
			}

			$attachmentFields = '
						<tr>
							<td align="right" valign="top">
								<font size="2"><b>' . $txt['yse119'] . ':</b></font><br /><br />
							</td>
							<td>
								' . $attachmentp . '<br />
								<input type="file" size=48 name="attachment" value="' . $attachmentp . '" /><br />
								<font size="1">' . $txt['yse120'] . ': ' . $modSettings['attachmentExtensions'] . '<br />
								' . $txt['yse121'] . ': ' . $modSettings['attachmentSizeLimit'] . ' KB</font><br /><br />
							</td>
						</tr>';
		}

		if ($username == 'Guest' && $modSettings['attachmentEnableGuest'] == 0)
			$attachmentFields = '';

		if ($modSettings['attachmentMemberGroups'] != '')
				if (!in_array($settings[7], explode(',', trim($modSettings['attachmentMemberGroups']))))
					$attachmentFields = "";

		$notification = (!$enable_notification || $username == 'Guest') ? '' : '
						<tr>
							<td align="right">
								<font size="2"><b>' . $txt[131] . ':</b></font>
							</td>
							<td>
								<font size="2"><input type="checkbox" name="notify" ' . $notify . ' /></font> <font size="1"> ' . $txt['yse14'] . '</font>
							</td>
						</tr>';

		$lockthread = ($settings[7] != 'Administrator' && $settings[7] != 'Global Moderator' && !in_array($username, $moderators)) ? '' : '
						<tr>
							<td align="right">
								<font size="2"><b>' . $txt['yse13'] . ':</b></font>
							</td>
							<td>
								<font size="2"><input type="checkbox" name="lock" ' . $lock . ' /></font> <font size="1"> ' . $txt['yse15'] . '</font>
							</td>
						</tr>';

		if (isset($linkcalendar))
			CalendarAddHidden();

		echo '
					' . $lockthread . '
					' . $notification . '
						<tr>
							<td align="right">
								<font size="2"><b>' . $txt[276] . ':</b></font><br /><br />
							</td>
							<td>
								<input type="checkbox" name="ns" value="NS" ' . $ns . ' /> <font size="1"> ' . $txt[277] . '</font><br /><br />
							</td>
						</tr>

					' . $attachmentFields . '
						<tr>
							<td align="center" colspan="2">
								<font size="1" class="text1" color="#000000"><font style="font-weight:normal" size="1">' . $txt['yse16'] . '</font></font><br />
								<input type="hidden" name="waction" value="post" />
								<input type="submit" name="post" value="' . $submittxt . '" onclick="WhichClicked' . "('post')" . ';" accesskey="s" />
								<input type="submit" name="$waction" value="' . $txt[507] . '" onclick="WhichClicked' . "('$waction')" . ';" accesskey="p" />
								<input type="reset" value="' . $txt[278] . '" accesskey="r" />
							</td>
						</tr>';
	}
	else
	{
		echo '
					<tr>
						<td align="center" colspan="2">
							<input type="hidden" name="waction" value="imsend" />
							<input type="submit" value="' . $submittxt . '" onclick="WhichClicked' . "('imsend')" . ';" accesskey="s" />
							<input type="submit" name="preview" value="' . $txt[507] . '" onclick="WhichClicked' . "('previewim')" . ';" accesskey="p" />
							<input type="reset" value="' . $txt[329] . '" accesskey="r" />
						</td>
					</tr>';
	}

	echo '
					<tr>
						<td colspan="2"></td>
					</tr>
				</table>
				<input type="hidden" name="sc" value="' . $sc . '" />
			</form>
		</td></tr></table>';

	if ($threadid > 0 && $waction != 'previewmodify' && $waction != 'previewim')
		doshowthread();

	footer();
	obExit();
}

function Post2 ()
{
	global $name, $email, $username, $subject, $message, $icon, $ns, $threadid, $txt, $notify, $MaxMessLen, $db_prefix;
	global $settings, $board, $mreplies, $maxmessagedisplay, $enable_guestposting, $waction, $ID_MEMBER, $ubbcjspath;
	global $REMOTE_ADDR, $cgi, $yySetLocation, $color, $sourcedir, $realname, $lock, $settings, $moderators, $doLimitOne;
	global $attachment, $attachment_size, $attachment_name, $HTTP_POST_FILES, $modSettings, $isAnnouncement;
	global $linkcalendar, $month, $day, $year, $evtitle, $span, $timeoffset;

	checkSession();
	if (isset($linkcalendar))
	{
		include_once "$sourcedir/Calendar.php";
		CalendarValidatePost();
	}

	if ($username == 'Guest' && $enable_guestposting == 0)
		fatal_error($txt[165]);

	if ($threadid != '' && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator' && !in_array($username, $moderators))
	{
		$request = mysql_query("
			SELECT locked
			FROM {$db_prefix}topics
			WHERE ID_TOPIC=$threadid") or database_error(__FILE__, __LINE__);

		list($tmplocked) = mysql_fetch_array($request);
		if ($tmplocked != 0)
			fatal_error($txt[90]);        // don't allow a post if it's locked
	}

	if ($threadid == '')
		$request = mysql_query("
			SELECT b.ID_BOARD
			FROM {$db_prefix}boards AS b, {$db_prefix}categories AS c
			WHERE b.ID_BOARD=$board
				AND c.ID_CAT=b.ID_CAT
				AND (FIND_IN_SET('$settings[7]', c.memberGroups) != 0 OR c.memberGroups = '' OR '$settings[7]' LIKE 'Administrator' OR '$settings[7]' LIKE 'Global Moderator')") or database_error(__FILE__, __LINE__);
	else
		$request = mysql_query("
			SELECT t.ID_TOPIC
			FROM {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}categories AS c
			WHERE t.ID_TOPIC=$threadid
				AND b.ID_BOARD=$board
				AND b.ID_BOARD=t.ID_BOARD
				AND c.ID_CAT=b.ID_CAT
				AND (FIND_IN_SET('$settings[7]', c.memberGroups) != 0 OR c.memberGroups = '' OR '$settings[7]' LIKE 'Administrator' OR '$settings[7]' LIKE 'Global Moderator')") or database_error(__FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
		fatal_error($txt[1]);

	// If poster is a Guest then evaluate the legality of name and email
	if ($username == 'Guest')
	{
		$name = trim($name);
		if ($name == '' || $name == '_' || $name == ' ')
			fatal_error($txt[75]);

		if (strlen($name) > 25)
			fatal_error($txt[568]);

		if ($email == '')
			fatal_error($txt[76]);

		if (!preg_match("/^[0-9A-Za-z@\._\-]+$/", $email))
			fatal_error($txt[243]);
	}

	if (!empty($threadid) && !is_numeric($threadid))
		fatal_error($txt[337]);

	// did they toggle lock topic after post?
	$locked = (($settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' || in_array($username, $moderators)) && $lock == 'on')? 1 : 0 ;
	$isLocked = ($locked ? ', locked=1' : '');
	$name = htmlspecialchars($name);
	$email = htmlspecialchars($email);

	if (trim($subject) == '')
		fatal_error($txt[77]);

	if (trim($subject) == '')
		fatal_error($txt[77]);

	if (trim($message) == '')
		fatal_error($txt[78]);

	if (strlen($message) > $MaxMessLen)
		fatal_error($txt[499]);

	if ($waction == 'preview')
		Preview();

	spam_protection();

	if (strlen($subject) > 80)
	{
		$subject = substr($subject, 0, 80);
		if (substr($subject, -1) == '\\')
			$subject = substr($subject, 0, 79);
	}

	$message = htmlspecialchars($message, ENT_QUOTES);
	$subject = htmlspecialchars($subject);

	if ($username != 'Guest')                # If not guest, get name and email.
	{
		$name = $username;
		$email = $settings[2];
	}

	// Preparse code (zef)
	$message = preparsecode($message, $realname, $name);

	$message = str_replace(array("\r", "\n", "\t"), array('', '<br />', '&nbsp;&nbsp;&nbsp;'), $message);

	if ($username == 'Guest')
	{
		# If user is Guest, then make sure the chosen name
		# is not reserved or used by a member.
		#
		if (get_magic_quotes_gpc() == 0)
			$name = mysql_escape_string($name);

		$request = mysql_query("
			SELECT ID_MEMBER
			FROM {$db_prefix}members
			WHERE (memberName='$name' || realName='$name')") or database_error(__FILE__, __LINE__);

		if (mysql_num_rows($request) != 0)
			fatal_error($txt[473]);

		// now make sure they arn't trying to use a reserved name
		$request = mysql_query("
			SELECT *
			FROM {$db_prefix}reserved_names
			ORDER BY setting") or database_error(__FILE__, __LINE__);

		$matchword = $matchcase = $matchuser = $matchname = '';

		for ($i = 0; $i < 4; $i++)
		{
			$tmp = mysql_fetch_row($request);
			${$tmp[0]}=$tmp[1];
		}

		$namecheck = $matchcase ? $name : strtolower ($name);

		while ($tmp = mysql_fetch_row($request))
		{
			if ($tmp[0] == 'word')
			{
				$reserved = $tmp[1];
				$reservecheck = $matchcase ? $reserved : strtolower ($reserved);
				if ($matchname)
				{
					if ($matchword)
					{
						if ($namecheck == $reservecheck)
							fatal_error("$txt[244] $reserved");
					}
					else
					{
						if (strstr($namecheck, $reservecheck))
							fatal_error("$txt[244] $reserved");
					}
				}
			}
		}
	}

	// Validate the attachment if there is one

	// replace as much special characters as possible and remove all other characters
	$HTTP_POST_FILES['attachment']['name'] = preg_replace(
		array("/\s/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/", "/[]/",	"/[]/", "/[^\w_.-]/"),
		array('_', 'a', 'A', 'o', 'O', 'e', 'E', 'u', 'U', 'i', 'I', 'c', 'n', 'N', ''), 
		$HTTP_POST_FILES['attachment']['name']);


	if ($HTTP_POST_FILES['attachment']['name'] != "")
	{
		if ($HTTP_POST_FILES['attachment']['size'] > $modSettings['attachmentSizeLimit'] * 1024)
			fatal_error("$txt[yse122] $modSettings[attachmentSizeLimit] $txt[yse211].");

		if ($modSettings['attachmentCheckExtensions'] == '1')
			if (!in_array(strtolower(substr(strrchr($HTTP_POST_FILES['attachment']['name'], '.'), 1)), explode(',', strtolower($modSettings['attachmentExtensions']))))
			{
				$failed = $HTTP_POST_FILES['attachment']['name'];
				fatal_error("$failed.<br />$txt[yse123] $modSettings[attachmentExtensions].");
			}

		// make sure they aren't trying to upload a nasty file
		$disabledFiles = array('CON','COM1','COM2','COM3','COM4','PRN','AUX','LPT1');
		if (in_array(strtoupper(substr(strrchr($HTTP_POST_FILES['attachment']['name'], '.'), 1)), $disabledFiles))
		{
			$failed = $HTTP_POST_FILES['attachment']['name'];
			fatal_error("$failed.<br />$txt[yse130b].");
		}

		if (file_exists($modSettings['attachmentUploadDir'] . "/" . $HTTP_POST_FILES['attachment']['name']))
			fatal_error($txt[yse125]);

		$dirSize = '0';
		$dir = opendir($modSettings['attachmentUploadDir']);
		while ($file = readdir($dir))
			$dirSize = $dirSize + filesize($modSettings['attachmentUploadDir'] . '/' . $file);

		if ($HTTP_POST_FILES['attachment']['size'] + $dirSize > $modSettings['attachmentDirSizeLimit'] * 1024)
			fatal_error($txt[yse126]);

		$parts = isset($HTTP_POST_FILES['attachment']) ? preg_split("~(\\|/)~", $HTTP_POST_FILES['attachment']['name']) : array();
		$destName = array_pop($parts);

		if (!move_uploaded_file($HTTP_POST_FILES['attachment']['tmp_name'], $modSettings['attachmentUploadDir'] . '/' . $destName))
			fatal_error("$txt[yse124]");
		$attachment_size = $HTTP_POST_FILES['attachment']['size'];

		chmod ("$modSettings[attachmentUploadDir]/$destName",0644) || $chmod_failed = 1;
	}
	else
		$HTTP_POST_FILES['attachment']['name'] = 'NULL';

	// If no thread specified, this is a new thread.
	// Find a valid random ID for it.
	$newtopic = ($threadid == '') ? true : false;
	$time = time();
	$se = ($ns ? 0 : 1);

	if (get_magic_quotes_gpc() == 0)
	{
		$subject = mysql_escape_string($subject);
		$message = mysql_escape_string($message);
	}

	if ($newtopic)        // This is a new topic. Save it.
	{
		if ($isAnnouncement && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator' && !in_array($username, $moderators))
			fatal_error($txt['announcement1']);

		$tmpname = ($HTTP_POST_FILES['attachment']['name'] == 'NULL') ? 'NULL' : "'" . mysql_escape_string($HTTP_POST_FILES['attachment']['name']) . "'";
		$request = mysql_query("
			INSERT INTO {$db_prefix}messages (ID_MEMBER, subject, posterName, posterEmail, posterTime, posterIP, smiliesEnabled, body, icon, attachmentSize, attachmentFilename)
			VALUES ($ID_MEMBER, '$subject', '$name', '$email', $time, '$REMOTE_ADDR', $se, '$message', '$icon', '$attachment_size', $tmpname)") or database_error(__FILE__, __LINE__);

		$ID_MSG = mysql_insert_id();
		if ($ID_MSG > 0)
		{
			$request = mysql_query("
				INSERT INTO {$db_prefix}topics (ID_BOARD, ID_MEMBER_STARTED, ID_MEMBER_UPDATED, ID_FIRST_MSG, ID_LAST_MSG, locked, numViews)
				VALUES ($board, $ID_MEMBER, $ID_MEMBER, $ID_MSG, $ID_MSG, $locked, 0)") or database_error(__FILE__, __LINE__);

			if (mysql_insert_id() > 0)
			{
				$threadid = mysql_insert_id();
				$request = mysql_query("
					UPDATE {$db_prefix}messages
					SET ID_TOPIC = $threadid
					WHERE (ID_MSG = $ID_MSG)") or database_error(__FILE__, __LINE__);

				$request = mysql_query("
					UPDATE {$db_prefix}boards
					SET numPosts = numPosts + 1, numTopics = numTopics + 1
					WHERE (ID_BOARD = $board)") or database_error(__FILE__, __LINE__);

				$mreplies = 0;

				if ($modSettings['trackStats'] == 1)
				{
					$date = getdate(time() + $timeoffset * 3600);
					$statsquery = mysql_query("
						UPDATE {$db_prefix}log_activity
						SET topics = topics + 1, posts = posts + 1
						WHERE month = $date[mon]
							AND day = $date[mday]
							AND year = $date[year]") or database_error(__FILE__, __LINE__);

					if (mysql_affected_rows() == 0)
						$statsquery = mysql_query("
							INSERT INTO {$db_prefix}log_activity
							(month, day, year, topics, posts)
							VALUES ($date[mon], $date[mday], $date[year], 1, 1)") or database_error(__FILE__, __LINE__);
				}

				if (isset($linkcalendar))
					CalendarInsertEvent($board, $threadid, $evtitle, $ID_MEMBER, $month, $day, $year, $span);

				if ($isAnnouncement)
				{
					$reqAnn = mysql_query("
						SELECT b.notifyAnnouncements
						FROM {$db_prefix}boards as b, {$db_prefix}categories as c
						WHERE (b.ID_BOARD = $board
							AND b.ID_CAT = c.ID_CAT)") or database_error(__FILE__, __LINE__);

					$rowAnn = mysql_fetch_array($reqAnn);

					if ($rowAnn['notifyAnnouncements'])
						NotifyUsersNewAnnouncement();
				}

				updateStats('topic');
				updateStats('message');
				UpdateLastMessage($board);
			}
		}
	}
	else                        # This is an old thread. Save it.
	{
		$tmpname = ($HTTP_POST_FILES['attachment']['name'] == 'NULL') ? 'NULL' : "'" . mysql_escape_string($HTTP_POST_FILES['attachment']['name']) . "'";
		$request = mysql_query("
			INSERT INTO {$db_prefix}messages (ID_TOPIC, ID_MEMBER, subject, posterName, posterEmail, posterTime, posterIP, smiliesEnabled, body, icon, attachmentSize, attachmentFilename)
			VALUES ($threadid, $ID_MEMBER, '$subject', '$name', '$email', $time, '$REMOTE_ADDR', $se, '$message', '$icon', '$attachment_size', $tmpname)") or database_error(__FILE__, __LINE__);

		$ID_MSG = mysql_insert_id();

		if ($ID_MSG > 0)
		{
			$request = mysql_query("
				UPDATE {$db_prefix}topics
				SET ID_MEMBER_UPDATED = $ID_MEMBER, ID_LAST_MSG = $ID_MSG, numReplies = numReplies + 1 $isLocked
				WHERE (ID_TOPIC = $threadid)") or database_error(__FILE__, __LINE__);

			$request = mysql_query("
				UPDATE {$db_prefix}boards
				SET numPosts = numPosts + 1
				WHERE (ID_BOARD = $board)") or database_error(__FILE__, __LINE__);

			$mreplies++;

			if ($modSettings['trackStats'] == 1)
			{
				$date = getdate(time() + $timeoffset * 3600);
				$statsquery = mysql_query("
					UPDATE {$db_prefix}log_activity
					SET posts = posts + 1
					WHERE month = $date[mon]
					AND day = $date[mday]
					AND year = $date[year]") or database_error(__FILE__, __LINE__);

				if (mysql_affected_rows() == 0)
					$statsquery = mysql_query("
						INSERT INTO {$db_prefix}log_activity
						(month, day, year, posts)
						VALUES ($date[mon], $date[mday], $date[year], 1)") or database_error(__FILE__, __LINE__);
			}

			updateStats('message');
			UpdateLastMessage($board);
		}
	}

	if ($username != 'Guest')
	{
		$request = mysql_query("
			SELECT * FROM {$db_prefix}boards
			WHERE ID_BOARD = '$board'") or database_error(__FILE__, __LINE__);

		$pcount = mysql_fetch_array($request);
		$pcounter = $pcount['count'];

		if ($pcounter != 1)
		{
			++$settings[6];
			$request = mysql_query("
				UPDATE {$db_prefix}members
				SET posts = posts + 1
				WHERE ID_MEMBER = $ID_MEMBER
				$doLimitOne") or database_error(__FILE__, __LINE__);
		}

		# Mark thread as read for the member.
		$request = mysql_query("
			REPLACE INTO {$db_prefix}log_topics
			(logTime, ID_MEMBER, ID_TOPIC)
			VALUES (" . time() . ", $ID_MEMBER, $threadid)") or database_error(__FILE__, __LINE__);
	}

	# The thread ID, regardless of whether it's a new thread or not.
	$thread = $threadid;

	# Notify any members who have notification turned on for this thread.
	NotifyUsers();

	// turn notification on
	if ($notify != '')
	{
		include_once("$sourcedir/Notify.php");
		Notify2();
	}

	# Let's figure out what page number to show
	$start = (floor($mreplies / $maxmessagedisplay)) * $maxmessagedisplay;

	//  Remove this comment and comment out the other SetLocation so that you are returned
	//  to the same thread after posting.
	if ($modSettings['returnToPost'] == '1')
		$yySetLocation = "$cgi;board=$board;action=display;threadid=$thread;start=new";
	else
		$yySetLocation = $cgi;
	redirectexit();
}

function NotifyUsersNewAnnouncement ()
{
	global $subject, $threadid, $txt, $cgi, $db_prefix, $modSettings, $language, $chklngfile, $chklngfile2, $mbname;

	$Cond = ($modSettings['notifyAnncmnts_UserDisable'] == '1' ? ' WHERE notifyAnnouncements=1' : '');
	$request = mysql_query("
		SELECT emailAddress, lngfile
		FROM {$db_prefix}members
		$Cond
		ORDER BY lngfile") or database_error(__FILE__, __LINE__);

	$curlanguage = $chklngfile == Null ? $language : $chklngfile2;

	while ($row = mysql_fetch_array($request))
	{
		if ($modSettings['userLanguage'] == 1)
		{
			$desiredlanguage = (($row['lngfile'] == Null) || ($row['lngfile'] == '') ? $language : $row['lngfile']);
			if ($desiredlanguage != $curlanguage)
			{
				include($desiredlanguage);
				$curlanguage = $desiredlanguage;
			}
		}

		CensorTxt($subject);
		$send_subject = "$txt[notifyXAnn2]: $subject";
		$send_body = "$txt[notifyXAnn3] $cgi;action=display;threadid=$threadid;start=new\n\n" . $txt[130];
		sendmail($row['emailAddress'], $send_subject, $send_body);
	}
}

function NotifyUsers ()
{
	global $subject, $threadid, $txt, $cgi, $db_prefix, $realemail, $doLimitOne, $username, $language, $chklngfile, $chklngfile2, $mbname;
	global $ID_MEMBER, $modSettings;

	$request = mysql_query("
		SELECT notifies
		FROM {$db_prefix}topics
		WHERE (ID_TOPIC = $threadid
			AND notifies != '')
			LIMIT 1") or database_error(__FILE__, __LINE__);

	if (mysql_num_rows($request) != 0)
	{
		$row = mysql_fetch_row($request);

		$members = mysql_query("
			SELECT emailAddress, notifyOnce, ID_MEMBER, lngfile
			FROM {$db_prefix}members
			WHERE ID_MEMBER IN ('" . implode("','", explode(',', $row[0])) . "')
				AND emailAddress != ''
				AND ID_MEMBER != $ID_MEMBER
				ORDER BY lngfile") or database_error(__FILE__, __LINE__);

		$curlanguage = $chklngfile == Null ? $language : $chklngfile2;

		while ($rowmember = mysql_fetch_array($members))
		{
			if ($modSettings['userLanguage'] == 1)
			{
				$desiredlanguage = (($rowmember['lngfile'] == Null) || ($rowmember['lngfile'] == '') ? $language : $rowmember['lngfile']);
				if ($desiredlanguage != $curlanguage)
				{
					include($desiredlanguage);
					$curlanguage = $desiredlanguage;
				}
			}

			CensorTxt($subject);
			$send_subject = $txt[127] . ': ' . $subject;

			if ($rowmember['notifyOnce'] == 1)
			{
				$request = mysql_query("
					SELECT notificationSent
					FROM {$db_prefix}log_topics
					WHERE ID_MEMBER=$rowmember[ID_MEMBER]
						AND ID_TOPIC = $threadid
						$doLimitOne") or database_error(__FILE__, __LINE__);

				if (mysql_num_rows($request) == 0)
					$notificationSent = 0;
				else
					list($notificationSent) = mysql_fetch_row($request);

				if ($notificationSent == 0)
				{
					$send_body = "$txt[128] $txt[129] $cgi;action=display;threadid=$threadid;start=new\n\n$txt[notifyXOnce2]\n\n$txt[130]";
					sendmail($rowmember['emailAddress'], $send_subject, $send_body);

					if (mysql_num_rows($request) == 0)
						$request = mysql_query("
							INSERT INTO {$db_prefix}log_topics
							(logTime, ID_MEMBER, ID_TOPIC, notificationSent)
							VALUES (0, '$rowmember[ID_MEMBER]', $threadid, 1)") or database_error(__FILE__, __LINE__);
					else
						$request = mysql_query("
							UPDATE {$db_prefix}log_topics
							SET notificationSent = 1
							WHERE (ID_MEMBER = '$rowmember[ID_MEMBER]'
								AND ID_TOPIC=$threadid)") or database_error(__FILE__, __LINE__);
				}
			}
			else
			{
				$send_body = "$txt[128] $txt[129]  $cgi;action=display;threadid=$threadid;start=new\n\n$txt[130]";
				sendmail($rowmember['emailAddress'], $send_subject, $send_body);
			}
		}
	}
}

function doshowthread ()
{
	global $censored, $threadid, $enable_ubbc, $txt, $color, $db_prefix, $realNames, $modSettings, $settings;

	// how many messages to show
	$limitString = ($modSettings['topicSummaryPosts'] < 0) ? '' : (' LIMIT ' . (!is_numeric($modSettings['topicSummaryPosts']) ? '0' : $modSettings[topicSummaryPosts]));

	$request = mysql_query("
		SELECT m.posterName, m.posterTime, m.body, m.smiliesEnabled
		FROM {$db_prefix}messages AS m, {$db_prefix}topics as t, {$db_prefix}boards as b, {$db_prefix}categories as c
		WHERE m.ID_TOPIC='$threadid'
			AND t.ID_TOPIC=m.ID_TOPIC
			AND b.ID_BOARD=t.ID_BOARD
			AND c.ID_CAT=b.ID_CAT
			AND (FIND_IN_SET('$settings[7]', c.memberGroups) != 0 OR c.memberGroups = '' OR '$settings[7]' LIKE 'Administrator' OR '$settings[7]' LIKE 'Global Moderator')
		ORDER BY ID_MSG DESC
		$limitString") or database_error(__FILE__, __LINE__);

	if (mysql_num_rows($request) != 0)
	{
		echo '
			<br /><br />
			<table cellspacing="1" cellpadding="0" width="75%" align="center" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td>
						<table class="windowbg" cellspacing="1" cellpadding="2" width="100%" align="center" bgcolor="' . $color['windowbg'] . '">
							<tr>
								<td class="titlebg" bgcolor="' . $color['titlebg'] . '" colspan="2">
									<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[468] . '</b></font>
								</td>
							</tr>';

		while (list($tempname, $tempdate, $message, $es) = mysql_fetch_row($request))
		{
			$tempname = addslashes($tempname);
			LoadRealName($tempname);
			$realNames[$tempname] = stripslashes($realNames[$tempname]);

			$tempdate = timeformat($tempdate);

			CensorTxt($message);

			if ($enable_ubbc)
				$message = DoUBBC($message, $es);

			echo '
							<tr>
								<td align="left" class="catbg">
									<font size="1">' . $txt[279] . ': ' . $realNames[$tempname] . '</font>
								</td>
								<td class="catbg" align="right">
									<font size="1">' . $txt[280] . ': ' . $tempdate . '</font>
								</td>
							</tr>
							<tr>
								<td class="windowbg2" colspan="2" bgcolor="' . $color['windowbg2'] . '">
									<font size="1">' . $message . '</font>
								</td>
							</tr>';

		}

		echo '
						</table>
					</td>
				</tr>
			</table>';
	}
	else
		echo '<!--no summary-->';
}

function printPostBox($msg)
{
	global $txt, $enable_ubbc, $showyabbcbutt, $imagesdir, $ubbcjspath;
	
	$msg = str_replace(array('"', '<', '>'), array('&quot;', '&lt;', '&gt;'), $msg);

	if ($enable_ubbc && $showyabbcbutt)
	{
		echo '
			<tr>
				<td align="right">
					<font size="2"><b>' . $txt[252] . ':</b></font>
				</td>
				<td valign="middle">
					<a href="javascript:surroundText(\'[b]\',\'[/b]\')"><img src="' . $imagesdir . '/bold.gif" align="bottom" width="23" height="22" alt="' . $txt[253] . '" border="0" /></a><a href="javascript:surroundText(\'[i]\',\'[/i]\')"><img src="' . $imagesdir . '/italicize.gif" align="bottom" width="23" height="22" alt="' . $txt[254] . '" border="0" /></a><a href="javascript:surroundText(\'[u]\',\'[/u]\')"><img src="' . $imagesdir . '/underline.gif" align="bottom" width="23" height="22" alt="' . $txt[255] . '" border="0" /></a><a href="javascript:surroundText(\'[s]\',\'[/s]\')"><img src="' . $imagesdir . '/strike.gif" align="bottom" width="23" height="22" alt="' . $txt[441] . '" border="0" /></a><a href="javascript:surroundText(\'[glow=red,2,300]\',\'[/glow]\')"><img src="' . $imagesdir . '/glow.gif" align="bottom" width="23" height="22" alt="' . $txt[442] . '" border="0" /></a><a href="javascript:surroundText(\'[shadow=red,left]\',\'[/shadow]\')"><img src="' . $imagesdir . '/shadow.gif" align="bottom" width="23" height="22" alt="' . $txt[443] . '" border="0" /></a><a href="javascript:surroundText(\'[move]\',\'[/move]\')"><img src="' . $imagesdir . '/move.gif" align="bottom" width="23" height="22" alt="' . $txt[439] . '" border="0" /></a><a href="javascript:surroundText(\'[pre]\',\'[/pre]\')"><img src="' . $imagesdir . '/pre.gif" align="bottom" width="23" height="22" alt="' . $txt[444] . '" border="0" /></a><a href="javascript:surroundText(\'[left]\',\'[/left]\')"><img src="' . $imagesdir . '/left.gif" align="bottom" width="23" height="22" alt="' . $txt[445] . '" border="0" /></a><a href="javascript:surroundText(\'[center]\',\'[/center]\')"><img src="' . $imagesdir . '/center.gif" align="bottom" width="23" height="22" alt="' . $txt[256] . '" border="0" /></a><a href="javascript:surroundText(\'[right]\',\'[/right]\')"><img src="' . $imagesdir . '/right.gif" align="bottom" width="23" height="22" alt="' . $txt[446] . '" border="0" /></a><a href="javascript:replaceText(\'[hr]\')"><img src="' . $imagesdir . '/hr.gif" align="bottom" width="23" height="22" alt="' . $txt[531] . '" border="0" /></a><a href="javascript:surroundText(\'[size=2]\',\'[/size]\')"><img src="' . $imagesdir . '/size.gif" align="bottom" width="23" height="22" alt="' . $txt[532] . '" border="0" /></a><a href="javascript:surroundText(\'[font=Verdana]\',\'[/font]\')"><img src="' . $imagesdir . '/face.gif" align="bottom" width="23" height="22" alt="' . $txt[533] . '" border="0" /></a><br />

					<a href="javascript:surroundText(\'[flash=200,200]\',\'[/flash]\')"><img src="' . $imagesdir . '/flash.gif" align="bottom" width="23" height="22" alt="' . $txt[433] . '" border="0" /></a><a href="javascript:surroundText(\'[url]\',\'[/url]\')"><img src="' . $imagesdir . '/url.gif" align="bottom" width="23" height="22" alt="' . $txt[257] . '" border="0" /></a><a href="javascript:surroundText(\'[ftp]\',\'[/ftp]\')"><img src="' . $imagesdir . '/ftp.gif" align="bottom" width="23" height="22" alt="' . $txt[434] . '" border="0" /></a><a href="javascript:surroundText(\'[img]\',\'[/img]\')"><img src="' . $imagesdir . '/img.gif" align="bottom" width="23" height="22" alt="' . $txt[435] . '" border="0" /></a><a href="javascript:surroundText(\'[email]\',\'[/email]\')"><img src="' . $imagesdir . '/email2.gif" align="bottom" width="23" height="22" alt="' . $txt[258] . '" border="0" /></a><a href="javascript:surroundText(\'[table]\',\'[/table]\')"><img src="' . $imagesdir . '/table.gif" align="bottom" width="23" height="22" alt="' . $txt[436] . '" border="0" /></a><a href="javascript:surroundText(\'[tr]\',\'[/tr]\')"><img src="' . $imagesdir . '/tr.gif" align="bottom" width="23" height="22" alt="' . $txt[449] . '" border="0" /></a><a href="javascript:javascript:surroundText(\'[td]\',\'[/td]\')"><img src="' . $imagesdir . '/td.gif" align="bottom" width="23" height="22" alt="' . $txt[437] . '" border="0" /></a><a href="javascript:surroundText(\'[sup]\',\'[/sup]\')"><img src="' . $imagesdir . '/sup.gif" align="bottom" width="23" height="22" alt="' . $txt[447] . '" border="0" /></a><a href="javascript:surroundText(\'[sub]\',\'[/sub]\')"><img src="' . $imagesdir . '/sub.gif" align="bottom" width="23" height="22" alt="' . $txt[448] . '" border="0" /></a><a href="javascript:surroundText(\'[tt]\',\'[/tt]\')"><img src="' . $imagesdir . '/tele.gif" align="bottom" width="23" height="22" alt="' . $txt[440] . '" border="0" /></a><a href="javascript:surroundText(\'[code]\',\'[/code]\')"><img src="' . $imagesdir . '/code.gif" align="bottom" width="23" height="22" alt="' . $txt[259] . '" border="0" /></a><a href="javascript:surroundText(\'[quote]\',\'[/quote]\')"><img src="' . $imagesdir . '/quote2.gif" align="bottom" width="23" height="22" alt="' . $txt[260] . '" border="0" /></a><a href="javascript:replaceText(\'[list][*][*][*][/list]\')"><img src="' . $imagesdir . '/list.gif" align="bottom" width="23" height="22" alt="' . $txt[261] . '" border="0" /></a>

					<select name="txtcolor" onchange="surroundText(\'[color=\'+this.options[this.selectedIndex].value+\']\',\'[/color]\')">
						<option value="Black" selected="selected">' . $txt[262] . '</option>
						<option value="Red">' . $txt[263] . '</option>
						<option value="Yellow">' . $txt[264] . '</option>
						<option value="Pink">' . $txt[265] . '</option>
						<option value="Green">'. $txt[266] . '</option>
						<option value="Orange">' . $txt[267] . '</option>
						<option value="Purple">' . $txt[268] . '</option>
						<option value="Blue">' . $txt[269] . '</option>
						<option value="Beige">' . $txt[270] . '</option>
						<option value="Brown">' . $txt[271] . '</option>
						<option value="Teal">' . $txt[272] . '</option>
						<option value="Navy">' . $txt[273] . '</option>
						<option value="Maroon">' . $txt[274] . '</option>
						<option value="LimeGreen">' . $txt[275] . '</option>
					</select>
				</td>
			</tr>';
	}
	echo '
			<tr>
				<td align="right">
					<font size="2"><b>' . $txt[297] . ':</b></font>
				</td>
				<td valign="middle">
					<a href="javascript:replaceText(\' :)\')"><img src="' . $imagesdir . '/smiley.gif" align="bottom" alt="' . $txt[287] . '" border="0" /></a>
					<a href="javascript:replaceText(\' ;)\')"><img src="' . $imagesdir . '/wink.gif" align="bottom" alt="' . $txt[292] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :D\')"><img src="' . $imagesdir . '/cheesy.gif" align="bottom" alt="' . $txt[289] . '" border="0" /></a>
					<a href="javascript:replaceText(\' ;D\')"><img src="' . $imagesdir . '/grin.gif" align="bottom" alt="' . $txt[293] . '" border="0" /></a>
					<a href="javascript:replaceText(\' >:(\')"><img src="' . $imagesdir . '/angry.gif" align="bottom" alt="' . $txt[288] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :(\')"><img src="' . $imagesdir . '/sad.gif" align="bottom" alt="' . $txt[291] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :o\')"><img src="' . $imagesdir . '/shocked.gif" align="bottom" alt="' . $txt[294] . '" border="0" /></a>
					<a href="javascript:replaceText(\' 8)\')"><img src="' . $imagesdir . '/cool.gif" align="bottom" alt="' . $txt[295] . '" border="0" /></a>
					<a href="javascript:replaceText(\' ???\')"><img src="' . $imagesdir . '/huh.gif" align="bottom" alt="' . $txt[296] . '" border="0" /></a>
					<a href="javascript:replaceText(\' ::)\')"><img src="' . $imagesdir . '/rolleyes.gif" align="bottom" alt="' . $txt[450] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :P\')"><img src="' . $imagesdir . '/tongue.gif" align="bottom" alt="' . $txt[451] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :-[\')"><img src="' . $imagesdir . '/embarassed.gif" align="bottom" alt="' . $txt[526] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :-X\')"><img src="' . $imagesdir . '/lipsrsealed.gif" align="bottom" alt="' . $txt[527] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :-\\\\\')"><img src="' . $imagesdir . '/undecided.gif" align="bottom" alt="' . $txt[528] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :-*\')"><img src="' . $imagesdir . '/kiss.gif" align="bottom" alt="' . $txt[529] . '" border="0" /></a>
					<a href="javascript:replaceText(\' :\\\'(\')"><img src="' . $imagesdir . '/cry.gif" align="bottom" alt="' . $txt[530] . '" border="0" /></a>
				</td>
			</tr><tr>
				<td valign="top" align="right">
					<font size="2"><b>' . $txt[72] . ':</b></font>
				</td>
				<td>
					<textarea class="editor" name="message" rows="12" cols="60" onselect="javascript:storeCaret(this);" onclick="javascript:storeCaret(this);" onkeyup="javascript:storeCaret(this);" onchange="javascript:storeCaret(this);">' . $msg . '</textarea>
				</td>
			</tr>';
}

?>